package ru.dbotthepony.mc.otm.menu.widget

import ru.dbotthepony.mc.otm.block.entity.MatteryWorkerBlockEntity
import ru.dbotthepony.mc.otm.core.FloatSupplier
import ru.dbotthepony.mc.otm.menu.MatteryMenu
import java.util.function.BooleanSupplier

@Suppress("unused")
class ProgressGaugeWidget(menu: MatteryMenu) {
	var progressSupplier: FloatSupplier = FloatSupplier { 0f }
	var stuckSupplier: BooleanSupplier = BooleanSupplier { false }

	val percentage by menu.mSynchronizer.ComputedFloatField(getter = { progressSupplier.getAsFloat() })
	val isStuck by menu.mSynchronizer.ComputedBooleanField(getter = { stuckSupplier.asBoolean })

	constructor(
		menu: MatteryMenu,
		progress: FloatSupplier
	) : this(menu) {
		this.progressSupplier = progress
	}

	constructor(
		menu: MatteryMenu,
		blockEntity: MatteryWorkerBlockEntity<*>?
	) : this(menu) {
		if (blockEntity != null) {
			with(blockEntity)
		}
	}

	constructor(
		menu: MatteryMenu,
		progress: FloatSupplier,
		stuck: BooleanSupplier,
	) : this(menu) {
		this.progressSupplier = progress
		this.stuckSupplier = stuck
	}

	fun with(progress: FloatSupplier): ProgressGaugeWidget {
		this.progressSupplier = progress
		this.stuckSupplier = BooleanSupplier { false }
		return this
	}

	fun with(progress: FloatSupplier, stuck: BooleanSupplier): ProgressGaugeWidget {
		this.progressSupplier = progress
		this.stuckSupplier = stuck
		return this
	}

	fun with(blockEntity: MatteryWorkerBlockEntity<*>): ProgressGaugeWidget {
		with(blockEntity::workProgress, blockEntity::isUnableToProcess)
		return this
	}
}
